using System;
using System.Runtime.InteropServices;
using System.Threading;

/*
 * Thanks to PInvoke.net and Cypress for these definitions
 */

namespace CyUSB.Async {
	internal class NativeMethods {

		[DllImport("Kernel32", SetLastError = true, CharSet = CharSet.Unicode, ExactSpelling = true)]
		internal static unsafe extern bool DeviceIoControl(
			IntPtr hDevice,
			uint dwIoControlCode,
			SINGLE_TRANSFER* InBuffer,
			int nInBufferSize,
			byte [] OutBuffer,
			int nOutBufferSize,
			out int pBytesReturned,
			NativeOverlapped* overlapped);
	}

	[StructLayout(LayoutKind.Sequential, Pack = 1)]
	internal struct SETUP_PACKET {
		public byte bmRequest;
		public byte bRequest;
		public ushort wValue;
		public ushort wIndex;
		public ushort wLength;
		public uint dwTimeOut;
	}

	[StructLayout(LayoutKind.Sequential, Pack = 1)]
	internal struct SINGLE_TRANSFER {
		public SETUP_PACKET SetupPacket;
		public byte WaitForever;
		public byte ucEndpointAddress;
		public uint NtStatus;
		public uint UsbdStatus;
		public uint IsoPacketOffset;
		public uint IsoPacketLength;
		public uint BufferOffset;
		public uint BufferLength;
	}
}
